package pokus;

import javax.swing.*;
import javax.swing.event.*;

public class MyModel implements ListModel {

   private Object [] array;  
   
   public MyModel (Object [] a)
   {
       array = a;
   }
    
   @Override
    public int getSize() {
        return array.length;
    }

    @Override
    public Object getElementAt(int i) {
        return array [i];
    }
    
    public void set (int i, Object value)
    {
        if (i >= 0 && i < array.length)
        {
           array [i] = value;    
           if (listener != null)
           {
               // import javax.swing.event.*;
               ListDataEvent param = 
                       new ListDataEvent(this, ListDataEvent.CONTENTS_CHANGED, i, i);
               listener.contentsChanged(param);
           }
        }
    }
    
    public void add (int i, Object value)
    {
        if (i >= 0 && i <= array.length)
        {
           Object [] p = new Object [array.length + 1];
           for (int k = 0; k < array.length; k++)
               p[k] = array[k];
           for (int k = array.length-1; k >= i ; k--)
               p[k+1] = p[k];
           p[i] = value;
           array = p;
            
           if (listener != null)
           {
               ListDataEvent param = 
                       new ListDataEvent(this, ListDataEvent.INTERVAL_ADDED, i, i);
               listener.contentsChanged(param);
           }
        }
    }
    
    public void remove (int i)
    {
        if (i >= 0 && i <= array.length)
        {
           Object [] p = new Object [array.length - 1];
           for (int k = 0; k < i; k++)
               p[k] = array[k];
           for (int k = i+1; k < array.length ; k++)
               p[k-1] = array[k];
           array = p;
           
           if (listener != null)
           {
               ListDataEvent param = 
                       new ListDataEvent(this, ListDataEvent.INTERVAL_REMOVED, i, i);
               listener.contentsChanged(param);
           }
        }
    }
    
    ListDataListener listener;

    @Override
    public synchronized void addListDataListener(ListDataListener ll) {
        listener = ll;
        System.out.println ("Listener added");
    }

    @Override
    public synchronized void removeListDataListener(ListDataListener ll) {
        if (listener == ll)
        {
           listener = null;
           System.out.println ("Listener removed");
        }
    }
    
}
